#include "rnd.h"
#define RND_SKIP_NUM 64

static unsigned long x=123456789,y=362436069,z=521288629,w=88675123;

void srnd(unsigned int s){
    int i;
    x = s = 1812433253U * (s^(s>>30)) + 1;
    y = s = 1812433253U * (s^(s>>30)) + 2;
    z = s = 1812433253U * (s^(s>>30)) + 3;
    w = s = 1812433253U * (s^(s>>30)) + 4;
    // 偏り防止のため乱数系列の頭は捨てる
    for (i = 0 ; i < RND_SKIP_NUM ; i++){
        rnd();
    }
}
void srnd4(unsigned long sx, unsigned long sy, unsigned long sz,
           unsigned long sw)
{
    x = (sx != 0) ? sx : x;
    y = (sy != 0) ? sy : y;
    z = (sz != 0) ? sz : z;
    w = (sw != 0) ? sw : w;
}

// Xorshift RNGs
// George Marsaglia
// のxor128と同一コード
unsigned long rnd(void){
    unsigned long t;
    t = (x^(x<<11));
    x = y;
    y = z;
    z = w;
    w = (w^(w>>19))^(t^(t>>8));
    return w;
}

// min以上max以下の整数乱数を返す
int rrnd(int min, int max){
  int n;
  n = rnd() % (max-min+1) + min;
  //   n = (int)((double)rnd()*(max-min+1)/(RAND_MAX+1.0)) + min;
  return n;
}


